Last Comment Bug 1232742 - Enable OSX's CEMPEngine by default
: Enable OSX's CEMPEngine by default
Status: RESOLVED FIXED
:
Product: Core
Classification: Components
Component: Canvas: WebGL (show other bugs)
: unspecified
: Unspecified Unspecified
-- normal (vote)
: mozilla46
Assigned To: Benoit Girard (:BenWa)
:
: Milan Sreckovic [:milan]
Mentors:
Depends on: 1223540
Blocks:
  Show dependency treegraph
 
Reported: 2015-12-15 10:55 PST by Benoit Girard (:BenWa)
Modified: 2016-01-05 11:13 PST (History)
6 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
fixed


Attachments
patch (2.45 KB, patch)
2015-12-15 11:02 PST, Benoit Girard (:BenWa)
jmuizelaar: review+
Details | Diff | Splinter Review

Description User image Benoit Girard (:BenWa) 2015-12-15 10:55:02 PST
+++ This bug was initially created as a clone of Bug #1223540 +++
I experimented a bit with CEMPengine and the performance is generally very good.

We discussed this during the last WebGL session in Orlando. The consensus was that the approach is interesting and that we should consider shipping it if it's not much work. Our plan is to turn on the feature and if it proves problematic to ship we will disable it.

On the Unity benchmark[1] I get a 15% speed improvement (86856 vs. 100044).

The outcome of this will likely inform how we want to pursue remoting GL to another thread and/or process for performance reason.

[1] http://beta.unity3d.com/jonas/WebGLBenchmark/
Comment 1 User image Benoit Girard (:BenWa) 2015-12-15 11:02:28 PST
Created attachment 8698535 [details] [diff] [review]
patch
Comment 2 User image Benoit Girard (:BenWa) 2015-12-15 11:07:27 PST
This feature might be a good candidate for fuzzing. In the past jruderman did a 'drive-by' fuzzing of OSX's accelerated canvas feature when we were thinking of enabling it. Based on these results we decided not to ship the feature. Fuzzing here could be beneficial. General rendering fuzzing and WebGL fuzzing on the mac platform with this feature turned on should trigger the new code path.
Comment 4 User image Jeff Muizelaar [:jrmuizel] 2015-12-15 11:52:47 PST
Comment on attachment 8698535 [details] [diff] [review]
patch

Review of attachment 8698535 [details] [diff] [review]:
-----------------------------------------------------------------

Wait for 46
Comment 5 User image Al Billings [:abillings] 2015-12-15 16:10:28 PST
I'll mention the fuzzing aspect to the team. Thanks for pinging me on it, Benoit.
Comment 6 User image Jesse Ruderman 2015-12-15 16:22:30 PST
Already randomizing the pref in DOMFuzz:
https://github.com/MozillaSecurity/funfuzz/commit/9fef5bea3be144c526e1910b76a287c05b8f68c9

Anything new I need to do to fuzz this code well?
Comment 7 User image Benoit Girard (:BenWa) 2015-12-15 20:29:33 PST
Cool, I figured that might of been the case but I'm not familiar with how preferences are picked up.

As long as the fuzzing includes WebGL / web content on Mac then we should be covered. I'm assuming here that no news is good news.

Thanks!
Comment 8 User image Benoit Girard (:BenWa) 2015-12-23 12:41:59 PST
I'll enable this in early Jan 2016. If anything goes wrong I'll be more responsive to back it out then. NI for landing reminder.
Comment 9 User image Benoit Girard (:BenWa) 2016-01-04 11:55:47 PST
I'm leaving out the 'gfxPrefs.h' hunk. If the pref isn't read for some reason it can default to false.
Comment 10 User image Guilherme Lima 2016-01-05 10:07:14 PST
Apparently you landed this patch with the wrong number (1223540). Am I right?
Comment 11 User image Benoit Girard (:BenWa) 2016-01-05 10:48:21 PST
That's correct. It should of been this bug # :(

Note You need to log in before you can comment on or make changes to this bug.